#!/usr/bin/perl
# do not use embeded perl nagios for this
# nagios: -epn
use strict;
use warnings;
use Net::Jabber;
my $is_tls = 1;
my $debug = 0;
my $jabbercmport = '5222';
my $username = 'netsaint_test';

my $host_ip = shift;
my $jabbercm = shift;
my $password = shift;

sub xml_clean {
	my $text = shift;

	$text =~ s/\&/\&amp;/g;
	$text =~ s/</\&lt;/g;
	$text =~ s/>/\&gt;/g;
	$text =~ s/\"/\&quot;/g;
	$text =~ s/\'/\&apos;/g;

	return $text;
}
my $clean_pass = xml_clean($password);

my $ocon = new Net::Jabber::Client(debuglevel=>$debug,file=>'stdout');
if (!$ocon->Connect('hostname'=>$jabbercm,'port'=>$jabbercmport,tls=>$is_tls)) {
	print "Connection error\n";
	exit 2;
} else {
	my @resp = $ocon->AuthSend(username=>$username,password=>$clean_pass,resource=>'Default',tls=>$is_tls);
	if ($resp[0] && $resp[0] eq "ok") {
		print "Ejabberd is cool\n";
		exit 0;
	} else {
		print "Authentication failed\n";
		exit 2;
	}
}
