#!/usr/bin/perl

my $host = shift @ARGV;
my $count;
my $on;
my %state;

$ENV{'PATH'} = '/bin';
$ENV{'USER'} = 'root';
my $path = $ENV{'PATH'};

unless ($host =~ m/^([\d.]+)$/) {
	die"$host is an invalid ip address\n";
}
$host = $1;



open(C,"/usr/bin/rsh -l root $host quota|");

# read the output

while (my $line = <C>) {
	chomp;
	my ($vol,$state) = $line =~ /(\w+): quotas are (.+)\./;
	next unless $vol;
#	print "vol $vol, state $state\n";
	$state{$vol} = $state;
	if ( $state =~ /off/ ) {
		$crit = 1;
		push(@crit,$vol);
	}
	elsif ( $state =~ /init/ ) {
		$warn = 1;
		push(@warn,$vol);
	}
	elsif ( $state eq 'on' ) {
		$on++;
	}
	$count++;
}
close(C);




if ( $crit == 1 ) {
	foreach $v (@crit) {
		print $v . " " . $state{$v} . "\n";
	}
	exit 2;
}
elsif ( $warn == 1 ) {
	foreach $v (@warn) {
		print $v . " " . $state{$v} . "\n";
	}
	exit 1;
}

# to catch errors because putting an OR after the open doesn't work in the case rsh can't connect...

if ( $on >= 1 ) {
	print "quotas okay on $on volumes\n";
	exit 0;
}
else {
	print "something went wrong\n";
	exit -1;
}
