#!/usr/bin/perl

use Net::Telnet;
use strict;

my $host = shift;
my $match;
my $prematch;

my $t = new Net::Telnet (Timeout => 10);

$t->open( Host => $host, Port => 5222);

$t->errmode("return");

$t->print("<?xml version='1.0'?><stream:stream xmlns='jabber:client' xmlns:stream='http://etherx.jabber.org/streams' to='test'>\n");
&end(2,"no response") unless ( $t->waitfor( Match => '/from=/', Timeout => "10") );
$t->print("<iq id='1' type='get'><query xmlns='jabber:iq:auth'><username>test</username></query></iq>\n");
&end(2,"failed after sending username") unless ( $t->waitfor( Match => '/token/', Timeout => "10") );
$t->print("<iq id='2' type='set'><query xmlns='jabber:iq:auth'><username>test</username><password>aSdF9630</password><resource>Default</resource></query></iq>");
#$t->print("<iq id='2' type='set'><query xmlns='jabber:iq:auth'><username>test</username><digest>d6d91ca74927873e862084468634330b72116b16</digest><resource>Default</resource></query></iq>");
if ( ($prematch,$match) = $t->waitfor( Match => '/result/', Timeout => "10") ) {
#if ( ($prematch,$match) = $t->waitfor( Match => '/Unauthorized/', Match => '/Disconnected/', Timeout => "5") ) {
#	print "$prematch\n\n$match\n";
#	print "jabber's cool\n";
	&end(0);
}
else {
#	print "$prematch\n$match\n";
#	print "can't log in\n";
	&end(2);
}

sub end {
#	print "exiting with $_[0]\n";
	if ( $_[0] == 2 ) {
		print "$_[1]\n";
		exit 2;
	}
	else {
		print "jabber's cool\n";
		exit 0;
	}
}
print "hit the end\n";
